#------------------------------------------------------------------------
# -*- mode: cmake -*-
#------------------------------------------------------------------------
# cx_target_dist( )
#------------------------------------------------------------------------

function(cx_target_dist)
  # Set default CPack variables if they are not already defined
  if (NOT DEFINED CPACK_PACKAGE_NAME)
    set(CPACK_PACKAGE_NAME "${PROJECT_NAME}" PARENT_SCOPE)
  endif()
  if (NOT DEFINED CPACK_PACKAGE_VERSION)
    set(CPACK_PACKAGE_VERSION "${PROJECT_VERSION}" PARENT_SCOPE)
  endif()
  if (NOT DEFINED CPACK_PACKAGE_CONTACT)
    set(CPACK_PACKAGE_CONTACT "Your Name <your.email@example.com>" PARENT_SCOPE)
  endif()
  if (NOT DEFINED CPACK_SOURCE_GENERATOR)
    set(CPACK_SOURCE_GENERATOR "TGZ;TBZ2" PARENT_SCOPE)
  endif()
  if (NOT DEFINED CPACK_SOURCE_IGNORE_FILES)
    set(CPACK_SOURCE_IGNORE_FILES
      "/build/;/\\\\.git/;\\\\.swp$;\\\\.DS_Store$"
      PARENT_SCOPE
      )
  endif( )
  # Enable CPack
  include(CPack)

  # Split the generators into a list
  string(REPLACE ";" " " GENERATORS "${CPACK_SOURCE_GENERATOR}")

  # Create a list to store the package filenames
  set(PACKAGE_FILE_NAMES "")

  # Loop through each generator and determine the file extension
  foreach(GENERATOR IN LISTS GENERATORS)
    if (GENERATOR STREQUAL "TGZ")
      set(PACKAGE_EXTENSION ".tar.gz")
    elseif (GENERATOR STREQUAL "TZ")
      set(PACKAGE_EXTENSION ".tar.Z")
    elseif (GENERATOR STREQUAL "TBZ2")
      set(PACKAGE_EXTENSION ".tar.bz2")
    elseif (GENERATOR STREQUAL "TXZ")
      set(PACKAGE_EXTENSION ".tar.xz")
    elseif (GENERATOR STREQUAL "ZIP")
      set(PACKAGE_EXTENSION ".zip")
    else()
      set(PACKAGE_EXTENSION ".tar.gz") # Default extension
    endif()
    # Define the package filename and add it to the list
    list(APPEND PACKAGE_FILE_NAME
      S "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}${PACKAGE_EXTENSION}")
  endforeach()

  # Define the custom target 'dist' to generate source tarballs
  #add_custom_target(dist
  #  COMMAND ${CMAKE_COMMAND} --build . --target package_source
  #  COMMAND ${CMAKE_COMMAND} -E echo "Source tarballs created: ${PACKAGE_FILE_NAMES}"
  #  )
endfunction( )

